// These Ajax routines require globals that should have been injected above at runtime

var g_data;     // Always cleared before modifying in case modification fails
var g_interval;

function ajax(url, data, flag, strip, pdata) {

    var req = null;

    clear(pdata);

    if (window.XMLHttpRequest)
        req = new XMLHttpRequest();
    else
        req = new ActiveXObject("Microsoft.XMLHTTP");

    if (req) {
        if (pdata)
            req.open("POST", url, flag);
        else
            req.open("GET", url, flag);

        req.setRequestHeader("Content-Type", "text/xml");
        req.setRequestHeader("ETag", "EWB");
        req.onreadystatechange = function() {
            if (req.readyState == 4) {          // Loaded
                if (req.status == 200) {        // OK
                    if (strip)
                        successr(req, data);
                    else
                        success(req, data);
                }
                else
                    failure(req, data);

                req = null;
            }
        }
        if (pdata)
            req.send(pdata);
        else
            req.send(null);
    }
    else
        alert("Could not create an XMLHttpRequest object.");
}

function clear(data) {

    var obj;

    if (!data)
        obj = g_data;
    else
        obj = document.getElementById(data);

    if (obj)  {
        try {
            obj.innerHTML = "<pre>" + "Busy..." + "</pre>";
        } catch(e) {
            obj.innerHTML = "<pre>" + "..." + "</pre>";
        }
    }
    else {
        try {
            g_data = "";
        } catch(e) {
            ;
        }
    }
}

function success(req, data) {

    var res = req.responseXML;
    var obj;

    if (data == 0)
        obj = g_data;
    else
        obj = document.getElementById(data);

    if (obj)  {
        try {
            obj.innerHTML = "<pre>" + res.getElementsByTagName('Data')[0].firstChild.nodeValue +"</pre>";
        } catch(e) {
            obj.innerHTML = "";
        }
    }
    else {
        try {
            g_data = res.getElementsByTagName('Data')[0].firstChild.nodeValue;
        } catch(e) {
            ;
        }
    }
}

function successr(req, data) {
    var res = req.responseXML;
    var obj = document.getElementById(data);
    if (obj)  {
        try {
            obj.innerHTML = "<pre>" + res.getElementsByTagName('Data')[0].firstChild.nodeValue.replace(/\n/g, ' ') +"</pre>";
        } catch(e) {
            return false;
        }
    }
}

function failure(req, data) {
    var res = req.responseXML;
    var obj = document.getElementById(data);
    if (obj) {
        if (obj.lastChild)
            obj.lastChild.nodeValue = 'Disconnected';
    }
    else {
        g_data.innerHTML = 'Failure';
    }
}

function fixinput() {
    var s = document.getElementsByTagName("input");
    var n = s.length;
    for (i=0; i<n; i++) {
        s[i].setAttribute('autocapitalize', 'off');
        s[i].setAttribute('autocomplete', 'off');
        s[i].setAttribute('autocorrect', 'off');
    }
}

function doCmd(cmd, data) {
    doLoadS('shell?cmd='+ cmd, data);
}

function doCmdVar(cmd) {
    return doLoadVar('shell?cmd='+ cmd);
}

function doCmdVarN(cmd) {
    return doLoadVarN('shell?cmd='+ cmd);
}

function doCmdVarA(cmd) {
   g_data = "";
   ajax('shell?cmd='+ cmd, null, true, false, null);
   return g_data;
}

function doLoad(url, data) {
    clearInterval(g_interval);
    g_interval = null;
    ajax(url, data, true, false, null);
}

function doLoadVar(url) {
   g_data = "";
   ajax(url, null, false, false, null);
   return g_data;
}

function doLoadVarN(url) {
   g_data = "";
   ajax(url, null, false, false, null);
   return g_data.slice('\n', -1);
}

function doLoadAlert(url) {
   g_data = "";
   ajax(url, null, false, false, null);
   alert(g_data);
}

function doLoadN(url) {
    var obj = document.getElementById('result');
    if (obj == null) {
        ajax(url, null, false, false, null);
    }
    else {
        ajax(url, 'result', false, false, null);
    }
}

function doLoadResult(url) {
    var obj = document.getElementById('result');
    if (obj == null) {
        alert("WARNING: No result element exists "+"["+url+"]");
        ajax(url, null, false, false, null);
    }
    else {
        ajax(url, 'result', false, false, null);
    }
}

function doLoadR(url, data) {
   url = 'shell?cmd=xml+httpgetr+'+ReturnUrl(url);
   ajax(url, data, true, true, null);
}

function doLoadText(url, data) {
   url = 'shell?cmd=xml+httpgetr+'+ReturnUrl(url);
   ajax(url, data, true, false, null);
}

function doLoadRX(url, data) {
   url = 'shell?cmd=xml+httpgetr+'+url;
   ajax(url, data, true, true, null);
}

function doLoadRS(url, data) {
   url = 'shell?cmd=xml+httpgetr+'+ReturnUrl(url);
   ajax(url, data, false, true, null);
}

function doLoadRT(url, data, period) {
   url = 'shell?cmd=xml+httpgetr+'+ReturnUrl(url);
   g_url = url;
   g_data = data;
   ajax(url, data, true, false, null);
   setInterval("ajax(g_url, g_data, true, false, null)", period*1000);
}

function doLoadS(url, data) {
   ajax(url, data, false, false, null);
}

function doLoadT(url, data, period) {
    g_url = url;
    g_data = data;
    g_period = period;
    ajax(url, data, true, false, null);
    g_interval = setInterval("ajax(g_url, g_data, true, false, null)", period*1000);
}

function doCancelT() {
    clearInterval(g_interval);
    g_interval = null;
}

function doResumeT() {
    doLoadT(g_url, g_data, g_period);
}

function doLoadPB(url, data, progress) {
    g_url = url;
    g_data = data;
    ajax(url, data, false, false, null);
    var s = new String(document.getElementById(data).innerHTML);
    s = s.substr(5);
    s = s.replace("</pre>", " ")
    s = s.replace(/,/g , "");
    var x = parseInt(s);

    if (isNaN(x)) {
        x = 0;
    }
    for (i=0; i<32; i++) {
        x = x/2;
        if (x<1)
            break;
    }
    var node = document.getElementById(progress);
    node.style.width = parseInt(i*4) + 'px';
    node.style.height = "12px";
}

function isVPN() {
    var vpn = doCmdVar('ns+nat32.vpn');
    if (vpn.indexOf('ERROR') == 0) return false;
    if (vpn.indexOf('not available') >= 0) return false;
    return true;
}

function doPostS(url, pdata, data) {
    ajax(url, data, false, false, pdata);
}

function popup(w, h) {
	if (w == undefined) {
		var w = "820";
	}
	if (h == undefined) {
		var h = "650";
	}
	eval ("win=window.open('','Popup','location=no,status=yes,menubar=no,toolbar=no,scrollbars=yes,resizable=yes,width="+w+",height="+h+"');");
    if (win)
	    win.focus();
}

function urlpopup(url, w, h) {
	if (w == undefined) {
		var w = "1280";
	}
	if (h == undefined) {
		var h = "640";
	}
    var specs = 'location=yes,status=yes,menubar=no,toolbar=no,scrollbars=yes,resizable=yes,width='+w+',height='+h;
	eval ("win=window.open(url,'Popup',specs);");
    if (win)
	    win.focus();
}

function urlpopupx(url, w, h) {
	if (w == undefined) {
		var w = "460";
	}
	if (h == undefined) {
		var h = "220";
	}
    var specs = 'location=no,status=no,menubar=no,toolbar=no,scrollbars=no,resizable=no,zoom=no,width='+w+',height='+h;
	eval ("win=window.open(url,'Popup',specs)");
    if (win)
	    win.focus();
}

function cmdWrite(cmd) {
    g_data = "";
    doLoadS('shell?cmd='+ cmd);
    g_data = g_data.slice('\n', -1);
    document.write(g_data);
}

function cmdWriteX(cmd) {
    if (location.hostname.search('nat32.com') == -1) {
        g_data = "";
        doLoadS('shell?cmd='+ cmd);
        g_data = g_data.slice('\n', -1);
        document.write(g_data);
    }
    else
        document.write("unknown");
}

function cmdWritePre(cmd) {
    g_data = "";
    doLoadS('shell?cmd='+ cmd);
    g_data = g_data.slice('\n', -1);
    document.write("<pre>"+g_data+"</pre>");
}

function docWrite(t) {
    document.write(t);
}

function hide_div(id) {
    document.getElementById(id).style.display = "none";
}
function show_div(id) {
    document.getElementById(id).style.display = "inline";
}

function show_div_block(id) {
    if (document.getElementById(id).style.display == "block")
        document.getElementById(id).style.display = "none";
    else
        document.getElementById(id).style.display = "block";
}

