// WebSocket Globals

    var g_wsID  = "0";
    var g_wsIDX = "0";
    var g_wsMSG = "0";

// WebSocket Methods

    function wsInit(arg) {
        if (arg == "0") {
            g_wsMSG = "WebSocket[" + g_wsIDX + "] [" + g_wsID + "] closed";
            wsClose(g_wsMSG);
        }
        else {
            g_wsID = arg;
            ws = new WebSocket(wsUrl(arg));    // See nat32.js
            ws.onopen = function(evt) { onOpen(evt) };
            ws.onclose = function(evt) { onClose(evt) };
            ws.onmessage = function(evt) { onMessage(evt) };
            ws.onerror = function(evt) { onError(evt) };
        }
    }

    function onOpen(evt) {
        wsSend("ws register " + g_wsID);
    }

    function onClose(evt) {
        wsWrite("WebSocket [" + g_wsID + "] closed");
    }

    function onMessage(evt) {
        var re0 = /WS\[[0-9]+\] /;
        var re1 = /[0-9]+/;
        var idx_str = evt.data.match(re0);
        if (idx_str) {
            g_wsIDX = idx_str[0].match(re1);
            g_wsMSG = evt.data;
        }
        wsExec(evt.data);
    }

    function onError(evt) {
        if (evt.data)
            alert('ERROR: ' + evt.data);
    }

    function wsSend(message) {
        ws.send(message);
    }

    function wsWrite(msg) {
        var el = document.getElementById(g_wsID);
        el.innerHTML += msg + "<br>";
        el.scrollTop = el.scrollHeight;
    }

    function wsClose(msg) {
        ws.close(1000, msg);
    }

    function wsExec(str) {
        var args = str.split(':');
        var f = window[args[0]];
        if (f) {
            if (args[1])
                window[args[0]](args[1]);
            else
                alert(f);
        }
        else
            wsWrite(str);
    }

